
import gameEngine.Engine;
import gameObjects.Minion;
import generated.ImageLoader;
import tools.MAConfigGenerator;
import tools.Names;
import tools.Tools;
import ui.UIEnd;
import ui.UIFight;
import ui.UIHelp;
import ui.UIIntro;
import ui.UIResult;
import ui.UIStats;

/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

/**
 * Point d'entrée de l'application, initialistation.
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 * creation :  4 novembre 2011
 * 
 */
public class Start {

	private static boolean playagain = true;
	
	public static Engine e = null;
	
	public static void main(String[] args) throws InterruptedException {
		//on initialise les outils
		Tools.PropertiesGenerator pg = new MAConfigGenerator();
		Tools._setPropertiesFile("./data/MinionsArena.properties");
		Tools._setPropertiesGenerator(pg);
		Tools t = Tools.getInstance();
		t.log("chargement des images...", false);
		String error = ImageLoader.Start();
		if(error == null)
			System.out.println("[FAIT]");
		else {
			t.log("[ECHEC]");
			t.logError("cant read: "+error);
			System.exit(0);
		}
		e = new Engine();

		UIEnd end = null;
		new UIIntro(e);
		new UIHelp(e);
		while (playagain) {
			//boucle de jeu
			Minion[] userminion = { 
					new Minion(Names.random(),0,Minion.GAUCHE),
					new Minion(Names.random(),1,Minion.GAUCHE), 
					new Minion(Names.random(),2,Minion.GAUCHE) };
			new UIStats(e,userminion);
			
			Minion[] iaminion = { 
					new Minion(Names.random(),0,Minion.DROITE),
					new Minion(Names.random(),1,Minion.DROITE), 
					new Minion(Names.random(),2,Minion.DROITE) };
			ia(userminion,iaminion);
			boolean victory = new UIFight(e,userminion,iaminion).isVictorious();
			new UIResult(e, victory);
			end = new UIEnd(e);
			playagain = end.replay;
		}
		e.windowClosing();
	}
	/**
	 * prepare des minions pour le combat
	 * @param userminion
	 * @param iaminion
	 */
	public static void ia(Minion[] userminion,Minion[] iaminion){
		//FIXME dev
		iaminion[0].autoset(1);
		iaminion[1].autoset(2);
		iaminion[2].autoset(3);
	}

}
