/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
package gameObjects;

import gameEngine.Activable;
import gameEngine.MouseEater;
import gameEngine.Renderable;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;


/**
 * boutton a texte
 * @author	Mikael GUILLEMOT
 * @version 	1.0
 * creation :  5 novembre 2011 
 *
 */
public class Button implements MouseEater,Renderable{

	private int x1,y1,w,h,x2,y2;
	private BufferedImage used=null;
	private BufferedImage base=null;
	private BufferedImage active=null;
	private Activable objectToActive=null;
	private int id=0;
	private String value = null;

	private Color orange = new Color(255,200,100);
	
	public void setActiveListener(Activable obj) {
		objectToActive=obj;
	}

	public void removeActiveListener() {
		objectToActive=null;
	}
	
	public Button(int x, int y, BufferedImage base, BufferedImage active,int id,String value) {
		//attention ici les 2 images doivent avoir la meme taille
		this.value = value;
		this.base = base;
		this.active = active;
		this.used = this.base;
		h=used.getHeight();
		w=used.getWidth();
		this.id = id;
		setPosition(x, y);
	}
	
	public void setPosition(int x, int y) {
		x1 = x;
		y1=y;
		x2=x1+w;
		y2=y1+h;
	}
	/* (non-Javadoc)
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		buffer.drawImage(used, x1, y1, null);
		buffer.setPaint(orange);
		buffer.drawString(value, x1+5, y1+15);
	}

	/* (non-Javadoc)
	 * @see gameEngine.MouseEater#updateMouse(int, int, int)
	 */
	@Override
	public void updateMouse(int xm, int ym, int button,int state) {
		if(state == MouseEater.Released)
			used = base;
		if(xm<x2 && xm>x1 && ym<y2 && ym>y1) {
			if(state == MouseEater.Pressed)
				used = active;
			if(state == MouseEater.Clicked) {
				if(objectToActive !=null)
					objectToActive.activate(id);
			}
		}
		
	}

}
