/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package gameObjects;

import gameEngine.Activable;
import gameEngine.Engine;
import gameEngine.MouseEater;
import gameEngine.MoveEater;
import gameEngine.Renderable;

import java.awt.Color;
import java.awt.Graphics2D;

/**
 * ici on gere les onglet, on a 3 monstres on fait un truc statique bien moche
 * en dur!
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0
 * creation :  5 novembre 2011
 * 
 */
public class Tabs implements Renderable, MouseEater, MoveEater {

	private final Color border = new Color(150, 150, 150);
	private final Color backfill = new Color(0, 0, 0, 100);
	private final Color halffill = new Color(100, 100, 100, 150);
	private final Color frontfill = new Color(150, 100, 100, 150);
	private Activable objectToActive;
	public static final int id = 1;

	private Minion[] minions = null;
	public int selected = 0;

	private int x0 = 50;
	private int x1 = 0;
	private int x2 = 0;
	private int x3 = 0;
	private int xm = 0;
	private int ym = 0;

	private boolean dispinf = false;

	public Tabs(Minion[] m) {
		minions = m;
		updateNamesPosition();

	}

	public void updateNamesPosition() {
		x1 = minions[0].name.length() * 6 + x0 + 40;
		x2 = minions[1].name.length() * 6 + x1 + 40;
		x3 = minions[2].name.length() * 6 + x2 + 40;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.MoveEater#updateMouse(int, int)
	 */
	@Override
	public void update(int x, int y) {
		if (x < x3 && x > x0 && y < 40 && y > 20) {
			xm = x;
			ym = y;
			dispinf = true;
		} else
			dispinf = false;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		// fond de base+top
		buffer.setPaint(halffill);
		buffer.fillRect(x0, 20, x3 - x0, 10);
		buffer.setPaint(backfill);
		buffer.fillRect(x0, 20, x3 - x0, 20);
		buffer.fillRect(10, 40, Engine.W - 20, Engine.H - 50);
		// font special
		buffer.setPaint(frontfill);
		if (selected == 0)
			buffer.fillRect(x0, 20, x1 - x0, 20);
		else if (selected == 1)
			buffer.fillRect(x1, 20, x2 - x1, 20);
		else
			buffer.fillRect(x2, 20, x3 - x2, 20);
		// bordure
		buffer.setPaint(border);
		buffer.drawRect(10, 40, Engine.W - 20, Engine.H - 50);
		buffer.drawRect(x0, 20, x1 - x0, 20);
		buffer.drawRect(x1, 20, x2 - x1, 20);
		buffer.drawRect(x2, 20, x3 - x2, 20);
		// text
		buffer.setPaint(Color.red);
		buffer.drawString(minions[0].name, x0 + 20, 35);
		buffer.drawString(minions[1].name, x1 + 20, 35);
		buffer.drawString(minions[2].name, x2 + 20, 35);

		// infobule
		if (dispinf) {
			buffer.setPaint(halffill);
			buffer.fillRect(xm + 30, ym, 120, 20);
			buffer.setPaint(border);
			buffer.drawRect(xm + 30, ym, 120, 20);
			buffer.drawString("changer de serviteur", xm + 35, ym + 15);
		}

	}

	public void setActiveListener(Activable obj) {
		objectToActive = obj;
		;
	}

	public void removeActiveListener() {
		objectToActive = null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.MouseEater#updateMouse(int, int, int)
	 */
	@Override
	public void updateMouse(int xm, int ym, int button, int state) {
		if (xm < x1 && xm > x0 && ym < 40 && ym > 20)
			selected = 0;
		else if (xm < x2 && xm > x1 && ym < 40 && ym > 20)
			selected = 1;
		else if (xm < x3 && xm > x2 && ym < 40 && ym > 20)
			selected = 2;
		
		if (state == MouseEater.Clicked) {
			if (objectToActive != null && xm < x3 && xm > x0 && ym < 40
					&& ym > 20)
				objectToActive.activate(id);

		}

	}

}
