/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/
package tools;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

import tools.Tools.PropertiesGenerator;


/**
 * generateur de configuration
 * @author	Mikael GUILLEMOT
 * @version 	1.0
 * creation :  4 novembre 2011
 *
 */
public class MAConfigGenerator implements PropertiesGenerator {

	String ls = Tools.lineSeparator;
	
	/* (non-Javadoc)
	 * @see tools.Tools.PropertiesGenerator#generate(java.lang.String)
	 */
	@Override
	public boolean generate(String fileName) {
		try {
			File f = new File(fileName);
			f.createNewFile();
			RandomAccessFile raf = new RandomAccessFile(f, "rw");
			raf.writeBytes("#default properties file for MinionsArena project:" + ls);
			raf.writeBytes("#[general purpose keys]:" + ls);
			raf.writeBytes("LOG_ACTIVE = false" + ls);
			raf.writeBytes("TIMESTAMP_ACTIVE = true" + ls);
			raf.writeBytes("SILENT_LOG = false" + ls);
			raf.writeBytes("LOG_PATH = log/" + ls);
			raf.writeBytes("CLEAR_LOG = false" + ls);
			raf.writeBytes("PICTURE_PATH = data/pictures/" + ls);
			raf.writeBytes("" + ls);
			raf.writeBytes("#[game engine keys]:" + ls);
			raf.writeBytes("REDEFINE_CURSOR = false" + ls);
			raf.writeBytes("ANTIALIASING = false" + ls);
			raf.writeBytes("FULSCREEN = false" + ls);
			raf.writeBytes("INIT_STAT = 50" + ls);
			raf.writeBytes("DMG_MULTI = 15" + ls);
			raf.writeBytes("IA_LVL = 0" + ls);
			raf.close();
		} catch (IOException e) {
			return false;
		}
		return true;
	}

}
