/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package ui;

import gameEngine.Activable;
import gameEngine.Engine;
import gameEngine.Renderable;
import gameObjects.GButton;
import generated.ImageLoader;

import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Toolkit;

/**
 * 
 * classe UI pour le choix de fin de partie
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0 creation : 5 novembre 2011
 * 
 */
public class UIEnd implements Renderable, Activable {

	private boolean isactive = true;
	public boolean replay = false;

	public UIEnd(Engine e) {
		Toolkit tk = Toolkit.getDefaultToolkit();
		if (e.overload_cursor) {
			Cursor cur = tk.createCustomCursor(ImageLoader.cursor, new Point(0,
					0), "hcur");
			e.setCursor(cur);
		}
		// ajout des bouttons
		GButton oui = new GButton(50, 300, ImageLoader.oui0, ImageLoader.oui1,
				1);
		GButton non = new GButton(500, 300, ImageLoader.non0, ImageLoader.non1,
				0);

		oui.setActiveListener(this);
		non.setActiveListener(this);

		e.addMouseEater(oui);
		e.addMouseEater(non);

		e.addRenderListener(this);
		e.addRenderListener(oui);
		e.addRenderListener(non);

		while (isactive)
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		oui.removeActiveListener();
		non.removeActiveListener();

		e.removeMouseEater(oui);
		e.removeMouseEater(non);

		e.removeRenderListener(oui);
		e.removeRenderListener(non);
		e.removeRenderListener(this);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		buffer.drawImage(ImageLoader.end, 0, 0, null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Activable#activate(int)
	 */
	@Override
	public void activate(int id) {
		if (id == 1)
			replay = true;
		isactive = false;
	}

}
