/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package ui;

import gameEngine.Engine;
import gameEngine.MouseEater;
import gameEngine.Renderable;
import generated.ImageLoader;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Toolkit;

/**
 * 
 * classe UI pour l'aide
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0 creation : 5 novembre 2011
 * 
 */
public class UIHelp implements Renderable, MouseEater {

	private boolean isactive = true;

	public UIHelp(Engine e) {
		e.addMouseEater(this);
		e.addRenderListener(this);
		Toolkit tk = Toolkit.getDefaultToolkit();
		if (e.overload_cursor) {
			Cursor cur = tk.createCustomCursor(ImageLoader.cursor, new Point(0,
					0), "hcur");
			e.setCursor(cur);
		}
		while (isactive)
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
		e.removeMouseEater(this);
		e.removeRenderListener(this);
		e = null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		// TODO buffer.drawImage(ImageLoader.intribg, 0, 0, null);
		buffer.setPaint(Color.BLUE);
		buffer.fillRect(10, 10, Engine.W - 20, Engine.H - 20);
		buffer.setPaint(Color.black);
		buffer.fillRect(20, 20, Engine.W - 40, Engine.H - 40);
		buffer.setPaint(Color.white);
		buffer.drawString(
				"Pour pouvoir combattre vous devez tout d’abord créer votre armée.",
				150, 50);
		buffer.drawString(
				"Vous avez une certaine puissance démoniaque à insuffler  à vos serviteurs.",
				150, 65);
		buffer.drawString(
				"L’écran suivant vous permettra de le faire. Leur force et leurs compétences en dépendent.",
				150, 80);
		buffer.drawString(
				"Pour chaque combat vous engagez 3 serviteurs, ils combattent individuellement mais peuvent",
				150, 95);
		buffer.drawString(
				"être inter changé au prix d’un tour de jeu (a moins de posséder la compétence \"changement rapide\").",
				150, 110);
		buffer.drawString("Préparez vous !", 150, 125);

		buffer.drawString("Cliquez pour continuer.", 320, 250);
		buffer.drawRect(310, 235, 150, 20);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.MouseEater#updateMouse(int, int, int, int)
	 */
	@Override
	public void updateMouse(int x, int y, int button, int state) {
		if (state == MouseEater.Clicked)
			isactive = false;
	}

}
