/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package ui;

import gameEngine.Engine;
import gameEngine.MouseEater;
import gameEngine.Renderable;
import generated.ImageLoader;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Toolkit;

/**
 * 
 * classe UI pour l'introduction
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0 creation : 5 novembre 2011
 * 
 */
public class UIIntro implements Renderable, MouseEater {

	private boolean isactive = true;
	private int imagecounter = 0;
	private int k = 0;
	private int sens = 1;

	public UIIntro(Engine e) {
		e.addMouseEater(this);
		e.addRenderListener(this);
		Toolkit tk = Toolkit.getDefaultToolkit();
		if(e.overload_cursor) {
		Cursor hcur = tk.createCustomCursor(ImageLoader.hidden,
				new Point(0, 0), "hcur");
		e.setCursor(hcur);
		}
		while (isactive)
			try {
				Thread.sleep(100);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
			e.removeMouseEater(this);
			e.removeRenderListener(this);
			e=null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		// affichage du feu
		if (imagecounter > 300) {
			buffer.drawImage(ImageLoader.fire0, 0, Engine.H - 236 + k, null);
			buffer.drawImage(ImageLoader.fire1, 0, Engine.H - 236 - k, null);
			if (imagecounter % 20 == 0)
				sens = sens * -1;
			k += sens;
		}
		if (imagecounter > 300 && imagecounter < 600) {
			buffer.setPaint(Color.yellow);
			buffer.drawString("VOUS etes un de ces demon!",
					300, 150);
		}
		// estomper feu
		if (imagecounter > 300 && imagecounter < 550) {
			buffer.setPaint(new Color(0, 0, 0, 255 - (imagecounter - 300)));
			buffer.fillRect(0, 0, Engine.W, Engine.H);
		}
		//affichage texte intro
		if (imagecounter < 600) {
			buffer.setPaint(Color.red);
			buffer.drawString("Quelque part au plus profond de la terre ...",
					150, 50);
			buffer.drawString("Les démons de l'enfer sont en proies à un  ennui mortel.",
					150, 65);
			buffer.drawString("Leur nouvelle occupation : organiser de sanglants combats entre leurs serviteurs !",
					150, 80);
		}
		// estomper text
		if (imagecounter > 350 && imagecounter < 600) {
			buffer.setPaint(new Color(0, 0, 0, 0 + (imagecounter - 350)));
			buffer.fillRect(0, 0, Engine.W, 200);
		}
		// on affiche le titre 600
		if (imagecounter > 600) {
			buffer.drawImage(ImageLoader.titre, 0, 50, null);
		}
		// affichage texte
		if (imagecounter > 620) {
			buffer.setPaint(Color.white);
			buffer.drawString("Cliquez pour continuer.", 320, 250);
			buffer.drawRect(310, 235, 150, 20);
		}
			imagecounter++;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.MouseEater#updateMouse(int, int, int, int)
	 */
	@Override
	public void updateMouse(int x, int y, int button, int state) {
		if (state == MouseEater.Clicked)
			isactive = false;
	}

}
