/*
Copyright 2011 MIKAEL GUILLEMOT

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */
package ui;

import gameEngine.Engine;
import gameEngine.MouseEater;
import gameEngine.Renderable;
import generated.ImageLoader;

import java.awt.Cursor;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Toolkit;

/**
 * 
 * classe UI pour l'affichage des resultats
 * 
 * @author Mikael GUILLEMOT
 * @version 1.0 creation : 6 novembre 2011
 * 
 */
public class UIResult implements Renderable, MouseEater {


	public UIResult(Engine e, boolean victory) {
		if(!victory)
			return;
		e.addMouseEater(this);
		e.addRenderListener(this);
		Toolkit tk = Toolkit.getDefaultToolkit();
		if(e.overload_cursor) {
		Cursor cur = tk.createCustomCursor(ImageLoader.cursor,
				new Point(0, 0), "hcur");
		e.setCursor(cur);
		}
		//while (isactive)
			try {
				Thread.sleep(3000);
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
			e.removeMouseEater(this);
			e.removeRenderListener(this);
			e=null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.Renderable#render(java.awt.Graphics2D)
	 */
	@Override
	public void render(Graphics2D buffer) {
		buffer.drawImage(ImageLoader.victory, 0, 0, null);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see gameEngine.MouseEater#updateMouse(int, int, int, int)
	 */
	@Override
	public void updateMouse(int x, int y, int button, int state) {

	}

}
